"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SolanaChain = void 0;
const sdk_connect_1 = require("@wormhole-foundation/sdk-connect");
const address_js_1 = require("./address.js");
class SolanaChain extends sdk_connect_1.ChainContext {
    async getTokenAccount(address, token) {
        const { getAssociatedTokenAddress } = await import('@solana/spl-token');
        const mint = new address_js_1.SolanaAddress(token).unwrap();
        const owner = new address_js_1.SolanaAddress(address).unwrap();
        const ata = await getAssociatedTokenAddress(mint, owner);
        return {
            chain: this.chain,
            address: new address_js_1.SolanaAddress(ata.toString()),
        };
    }
}
exports.SolanaChain = SolanaChain;
//# sourceMappingURL=chain.js.map